#include <sys/types.h>
#include <sys/socket.h>
#include <sys/errno.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <stdio.h>
#include <signal.h>
#include <netdb.h>
#include <sys/time.h>
#include <termio.h>
#include <string.h>

#define BUFF		1024		

#define	SOCK_INIT	110
#define SOCK_VER	120
#define SOCK_SOCK	130
#define SOCK_BIND	140
#define SOCK_CONNECT 150
#define SOCK_SEND	160
#define SOCK_SELECT	170
#define SOCK_RECV	180
#define SOCK_PARAM	190
#define SOCK_HENT	200
#define DEFAULT_TIMER	10
#define  HOSTPORT	25

#define  E_OK		0
#define  E_FILE		100
#define  ERR_COM	200
#define	 ERR_PARAM	300
#define	 E_HOST		400


#define HELO	"helo Lottie\n"
#define DBG	if(dbg){
#define	DEND	}

static int dbg=0;

#define	FP	stderr	

static int MakeConnectPeer(char *peerIP,unsigned short peerPort,int *sock,int *reason);
static int RecvFromServer(char *rbuffer,int *rlen,int socket,long time_out,int *reason);
static int SendToServer(char *sbuffer,int socket,int *reason);
static void ShutdownWinSock(int s);
static void ShutdownSock(int s);

static FILE	*fp2;

int  SendMail(char *filename,char *to[] ,char *from, char *server,int file_flag)
{
	int error;
	int socket;
	int reason;
	char	rbuffer[2048];
	char	sbuffer[2048];
	int	rlen;
	char	hostname[256];
	int	i;
	

	FILE	*fp;
	//Secret Command
	if((file_flag & 4) ==4) dbg=1;
	//Parameter Check
	if(to == NULL )
		return ERR_PARAM;
	if(from == NULL || *from == '\0')
		return ERR_PARAM;
	if(filename==NULL||*filename=='\0')
		return E_FILE;
	if(file_flag & 1 == 1){
		if((fp=fopen(filename,"r"))==NULL){
			return E_FILE;
		}
	}
DBG
	if((fp2=fopen("/tmp/lnsmail.log","a"))==NULL){
		return E_FILE;
	}
DEND
	if(server== NULL || *server=='\0'){
		return E_HOST;
	}

	strcpy(hostname,server);
	//*****************************************Connect()*****/
DBG
	fprintf(FP,"Peer\n");
DEND
	error=MakeConnectPeer(hostname,HOSTPORT,&socket,&reason);
	if(error){
DBG
		fprintf(FP,"MAIL 1 :%d \n",reason);
DEND
		return ERR_COM+1;
}
	//***********************************Send() & Recv()*****/
	*rbuffer='\0';
	//--------------Link SetUP
	error=RecvFromServer(rbuffer,&rlen, socket,5, &reason);
	if(error!=E_OK){
		ShutdownWinSock(socket);
DBG
		fprintf(FP,"MAIL 2 :%d \n",reason);
DEND
		return ERR_COM+2;
	}
	if(strncmp(rbuffer,"220",3)!=0){
		ShutdownWinSock(socket);
DBG
		fprintf(FP,"MAIL 3 :%d \n",reason);
DEND
		return ERR_COM+3;
	}
	//--------------HELP command
DBG
	printf("HELO\n");
DEND
	error=SendToServer(HELO,socket,&reason);
	if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 4 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+4;
	}
	error=RecvFromServer(rbuffer,&rlen, socket,5, &reason);
	if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 5 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+5;
	}
	if(strncmp(rbuffer,"250",3)!=0){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+6;
	}
	//--------------MAIL command
DBG
	fprintf(FP,"FROM\n");
DEND
	sprintf(sbuffer,"mail from:%s\n",from);
	error=SendToServer(sbuffer,socket,&reason);
	if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+7;
	}
	error=RecvFromServer(rbuffer,&rlen, socket,5, &reason);
	if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+8;
	}
	if(strncmp(rbuffer,"250",3)!=0){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+9;
	}
	//--------------RCPT command
DBG
	fprintf(FP,"TO\n");
DEND
	for(i=0;i<10 && to[i]!=NULL;i++){
		sprintf(sbuffer,"rcpt to:%s\n",to[i]);
DBG
		fprintf(FP,"%s\n",sbuffer);	
DEND
		error=SendToServer(sbuffer ,socket,&reason);
		if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
			ShutdownWinSock(socket);
			return ERR_COM+10;
		}
		error=RecvFromServer(rbuffer,&rlen, socket,5, &reason);
		if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
			ShutdownWinSock(socket);
			return ERR_COM+11;
		}
		if(strncmp(rbuffer,"250",3)!=0){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
			ShutdownWinSock(socket);
			return ERR_COM+12;
		}
	}

	//--------------DATA command
DBG
	fprintf(FP,"DATA\n");
DEND

	error=SendToServer("data\n",socket,&reason);
	if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+13;
	}
	error=RecvFromServer(rbuffer,&rlen, socket,5, &reason);
	if(error!=E_OK){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+14;
	}
	if(strncmp(rbuffer,"354",3)!=0){
DBG
		fprintf(FP,"MAIL 6 :%d \n",reason);
DEND
		ShutdownWinSock(socket);
		return ERR_COM+15;
	}
	//----------------BODY
DBG
	fprintf(FP,"BODY\n");
DEND


	if(file_flag & 1 ==1){
	//----Send Data in FILE
		for(;;){
			if(fgets(sbuffer,2000,fp)!=sbuffer){
DBG
				fprintf(FP,"BREAK\n");
DEND
				break;
			}
DBG
			fprintf(FP,"SEND:%s",sbuffer);
DEND
			error=SendToServer(sbuffer,socket,&reason);
			if(error!=E_OK){
DBG
				fprintf(FP,"NG0");
DEND
				break;
			}
		}
	}else{
	//----Send Data in MEMORY 
		error=SendToServer(filename,socket,&reason);
		if(error!=E_OK){
DBG
			fprintf(FP,"NG0");
DEND
		}
	}

DBG
	fprintf(FP,"DOT\n");
DEND
	error=SendToServer("\n.\n",socket,&reason);
	if(error!=E_OK){
DBG
	fprintf(FP,"NG0");
DEND
		ShutdownWinSock(socket);
		return ERR_COM+16;
	}
	error=RecvFromServer(rbuffer,&rlen, socket,5, &reason);
	if(error!=E_OK){
DBG
	fprintf(FP,"NG1");
DEND
		ShutdownWinSock(socket);
		return ERR_COM+17;
	}
	if(strncmp(rbuffer,"250",3)!=0){
DBG
	fprintf(FP,"NG2");
DEND
		ShutdownWinSock(socket);
		return ERR_COM;
	}
	//--------------QUIT command
DBG
	fprintf(FP,"QUIT\n");
DEND
	error=SendToServer("quit\n",socket,&reason);
	if(error!=E_OK){
		ShutdownWinSock(socket);
		return ERR_COM;
	}
	error=RecvFromServer(rbuffer,&rlen, socket,5, &reason);
	if(error!=E_OK){
		ShutdownWinSock(socket);
		return ERR_COM;
	}
	if(strncmp(rbuffer,"221",3)!=0){
		ShutdownWinSock(socket);
		return ERR_COM;
	}
DBG
	fflush(FP);
DEND
	//***********************************************Close()*/
	ShutdownSock(socket);
}



static int MakeConnectPeer(char *peerIP,unsigned short peerPort,int *sock,int *reason)
{
	struct sockaddr_in	m_addr;
	struct sockaddr_in	p_addr;
	int		s;

	struct hostent *hent;

	if(peerIP == NULL)
		return SOCK_PARAM;
	if(sock == NULL)
		return SOCK_PARAM;
	if(reason == NULL)
		return SOCK_PARAM;

	/*Socket*****************************************************/
	s=socket(AF_INET,SOCK_STREAM,0);
	if(s<=0){
		/*Socket Failure ******************************/
		*reason=0;
		return SOCK_SOCK;
	}
	
	/*bind********************************************************/
	m_addr.sin_family = AF_INET;
	m_addr.sin_port=0;
	m_addr.sin_addr.s_addr=htonl(INADDR_ANY);
	if(bind(s,(struct sockaddr *)&m_addr,sizeof(m_addr)) == -1){
		/*bind error********************************/
		*reason=SOCK_BIND;
		close(s);
		return SOCK_BIND;
	}
	/*Convert HOST to IP Address**********************************/
	/*peerIPʥɥå*/
	p_addr.sin_addr.s_addr=inet_addr(peerIP);
	if(p_addr.sin_addr.s_addr == INADDR_NONE){
		hent=gethostbyname(peerIP);
		if(hent==NULL){
			close(s);
			return SOCK_HENT;
		}
		p_addr.sin_addr.s_addr=*(unsigned long *)hent->h_addr_list[0];
	}
	/*connect*****************************************************/
	p_addr.sin_family = AF_INET;
	p_addr.sin_port=htons(peerPort);
	
	if(connect(s,(struct sockaddr *)&p_addr,sizeof(p_addr))==-1){
		/*connet Error*********************/
		*reason=-1;
		close(s);
		return SOCK_CONNECT;
	}
	*sock=s;
	return 0;
}



static void ShutdownSock(int s)
{
	close(s);
}
static void ShutdownWinSock(int s)
{
	close(s);
}


static int RecvFromServer(char *rbuffer,int *rlen,int socket,
					   long time_out,int *reason)
{
	unsigned long ulCmdArg;
	int	  nByte;
	int	i;
	fd_set	readfds;
	struct	timeval tv;

DBG
	printf("----\n");
DEND
	if(rbuffer == NULL )
		return SOCK_PARAM;
	if(socket < 0)
		return SOCK_PARAM;
	if(reason==NULL|| rlen == NULL)
		return SOCK_PARAM;
	memset(rbuffer,0,64);
	
	/*Recv*********************************************/
	ulCmdArg=1; /*Non blocked socket */
//	ioctl(socket,FIONBIO,&ulCmdArg);
	FD_ZERO(&readfds);
	FD_SET(socket,&readfds);
	tv.tv_sec=time_out;
	tv.tv_usec=0;
	i=select(32,&readfds,NULL,NULL,&tv);
	if(i<=0){
			*reason=-1;
			return SOCK_SELECT;
	}
	nByte=recv(socket,rbuffer,BUFF,0);
	if(nByte==-1){
			*reason=-1;
			return SOCK_RECV;
	}
	*rlen=nByte;
	rbuffer[nByte]='\0';
DBG
	printf("RECV:%s\n",rbuffer);
DEND
	return 0;
}

static int SendToServer(char *sbuffer,int socket,int *reason)
{
	int	  nByte;
	int	nByteToSend;
	int nTotalByteToSend;
	int slen;
	

	slen=strlen(sbuffer);
	if(sbuffer == NULL )
		return SOCK_PARAM;
	if(slen==0)
		return SOCK_PARAM;
	if(socket < 0)
		return SOCK_PARAM;
	if(reason==NULL )
		return SOCK_PARAM;
	
	nTotalByteToSend=nByteToSend=slen;
	/*Send******************************************/
	for(;nByteToSend;){
		nByte=send(socket,
				sbuffer+nTotalByteToSend-nByteToSend ,
				nByteToSend,
				0);
		if(nByte==-1){
				*reason=-1;
				return SOCK_SEND;
		}
		nByteToSend -= nByte;
	}
DBG
	printf("SEND:%s\n",sbuffer);
DEND
	return 0;
}
